// main.h by Kosei Demura 2010-7-31

#include "common.h"

#ifdef _MSC_VER
#pragma warning(disable:4244 4305)  // for VC++, no precision loss complaints
#endif

#ifdef dDOUBLE
#define dsDrawBox dsDrawBoxD
#define dsDrawSphere dsDrawSphereD
#define dsDrawCylinder dsDrawCylinderD
#define dsDrawCapsule dsDrawCapsuleD
#define dsDrawLine    dsDrawLineD
#endif

#define WALL_PARTS_NUM 4   // ǂ̐
#define PARTICLE_NUM 1000  // p[eBN
#define BEAM_NUM 1024      // [U[r[̖{
#define BEAM_LENGTH 30     // r[̓B [m]
#define LASER_LO_LIMIT  135  // [UXLȋpx[degree]
#define LASER_HI_LIMIT -135  // [UXLȋpx
#define URG_FIRST 0
#define URG_LAST  1024

typedef struct
{
    int skip_lines;
    int first_index;
    int last_index;
} laser_t;

enum laser_request_type
{
    URG_GD,
    URG_MD
};

static int steps = 0;
static int show = 1;
laser_t urg;



static dWorldID    world;
static dSpaceID    space;
static dGeomID     ground;
static dGeomID     wall_parts[WALL_PARTS_NUM];
static dGeomID     beam[BEAM_NUM];

static dJointGroupID contactgroup;
static dsFunctions fn;

MyObject wheel[NUM], base, neck, sensor, laser, ball;
dJointID joint[NUM], neck_joint, sensor_joint, laser_joint;

static dReal contact_pos[BEAM_NUM][3]; // [U[ƕ̂̌_
long *laser_data;     // [UZTŎ擾
int   laser_data_max = BEAM_NUM;

static const dReal  BALL_R    = 0.11;                // {[̔a [m]
static const dReal  BALL_P[3] = {1.0, 1.0, 0.14};    // {[̏ʒu [m]
static dReal v_r = 0.0,v_l = 0.0 ;                   // E,ԗւ̉]x [rad/s]
static dReal BASE_M    = 9.4;                        // Ԃ̎ [kg]

dReal BASE_R = 0.25, BASE_L = 0.05;                  // Ԃ̔aC [m]
static const dReal  SENSOR_M  = 0.05;                // ZT̎ [kg]
static const dReal  SENSOR_R = 0.1, SENSOR_L = 0.02; // ZT̔aC [m]

static const dReal  LASER_M  = 0.37;                   // [U̎ [kg]
static const dReal  LASER_R = 0.028, LASER_L = 0.087; // ZT̔aC [m]
dReal LASER_ANGLE = 0;


static const dReal  NECK_M = 0.5, NECK_R = 0.02, NECK_L = 0.5; // ̎ʁCaC

dReal WHEEL_BIG_R = 0.105;            // 傫ԗւ̔a
dReal WHEEL_SMALL_R = 0.5 * (WHEEL_BIG_R - 0.5 * BASE_L);  // ԗւ̔a
dReal WHEEL_W  = 0.0002, WHEEL_SMALL_M = 0.1, WHEEL_BIG_M = 0.2; // ԗւ̕,

static dReal START_X = 0, START_Y = 0, START_Z = 0.11; // ʒu

// 0: right panel, 1:left panel, 2:back panel, 3;bar,
// 4: right wall paper, 5: left wall paper, 6: back wall paper
static const dReal WALL_SIDES[WALL_PARTS_NUM][3] = {{0.1, 3.0, 2.0},
    {0.1, 3.0, 2.0}, {0.1, 3.0,  2.0}, {0.1, 3.0, 2.0}
};

static const dReal FIELD_SIDES[3] = {10,14,0};

extern void deadReckoning();

extern void getRealPos(double pos[2], double *course);
extern dReal heading();





